<!DOCTYPE html>
<html>

<head>
  <title> Tạo đơn hàng - dành cho Admin </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron py-4">
    <h1 class="text-center mb-5"> Create Pizza Order - For Admin </h1>
    <div class="form-group row">
      <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
      <div class="col-sm-4">
        <select id="size-select" class="form-control">
          <option value="NOT_SELECT_COMBO"> Chọn cỡ Combo (Combo size)</option>
          <option value="S"> Nhỏ</option>
          <option value="M"> Vừa</option>
          <option value="L"> Lớn</option>
        </select>
      </div>
      <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
      <div class="col-sm-4">
        <select class="form-control" id="select-drink">
          <option value="NOT_SELECT_DRINK">Chọn đồ uống</option>
        </select>
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Mã voucher</label>
      <div class="col-sm-4">
        <input id="voucher" type="text" class="form-control" placeholder="Voucher ID (mã voucher)">
      </div>
      <label  class="col-sm-2 col-form-label">Loại pizza</label>
      <div class="col-sm-4">
        <select id="select-type" class="form-control">
          <option value="NOT_SELECT_PIZZA"> Chọn loại pizza </option>
          <option value="Seafood"> Hải sản</option>
          <option value="Hawaii"> Ha wai </option>
          <option value="Bacon"> Thịt hun khói </option>
        </select>
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
      <div class="col-sm-4">
        <input id="fullname" type="text" class="form-control" placeholder="Họ và tên">
      </div>
      <label for="" class="col-sm-2 col-form-label">Email</label>
      <div class="col-sm-4">
        <input id="email" type="email" class="form-control" placeholder="Email">
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Số điện thoại</label>
      <div class="col-sm-4">
        <input id="phone" type="text" class="form-control" placeholder="Số điện thoại">
      </div>
      <label class="col-sm-2 col-form-label">Địa chỉ</label>
      <div class="col-sm-4">
        <input id="address" type="text" class="form-control" placeholder="Địa chỉ">
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Lời nhắn</label>
      <div class="col-sm-10">
        <textarea id="msg" class="form-control" placeholder="Lời nhắn"></textarea>
      </div>
    </div>
    <div class="form-group text-right">
      <button onclick="onBtnCreateOrderClick()" class="btn btn-primary">Create Order</button>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    const gREQUEST_CREATE_OK = 201
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      // load dữ liệu vào select car
      loadDataDrinkList();
    }
    function onBtnCreateOrderClick() {
      var vOrder = {
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVourcher: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoTen: "",
        thanhTien: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: "",

      }
      // B1 thu thập dữ liệu
      getDataToCreateOrder(vOrder)
      console.log(vOrder)
      // B2 Kiểm tra dữ liệu
      var vValidate =isDatavalidate(vOrder)
      if(vValidate==true){
        //B3 Gọi Api xử lý
        var xhr =new XMLHttpRequest()
        processApiToCreateOrder(vOrder,xhr)
        xhr.onreadystatechange=
        function(){
          if(this.status==gREQUEST_CREATE_OK&&this.readyState==gREQUEST_READY_STATUS_FINISH_AND_OK){
            console.log(xhr.responseText)
            alert("Tạo đơn hàng thành công")
            window.location.href="indexListView.html"
          }
        }
      }
    }


    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thực hiện call api để load dữ liệu vào drink list
    function loadDataDrinkList() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXhttp.send();
      vXhttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
          console.log(vXhttp.responseText); // ghi response text ra console.log
          handleLoadDataToSelectDrink(vXhttp);
        }
      };
    }

    // handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp) {
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
      console.log("array drink list = " + vArrayDrinkList.length);
      // load data to drink select
      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var bDrinkOptionElement = document.createElement("option");
        bDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        bDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(bDrinkOptionElement);
      }
    }
    // Hàm thu thập dữ liệu
    function getDataToCreateOrder(paramObject) {
      // Truy xuất từ form
      var vSizeComboSelect = document.getElementById("size-select")
      var vDrinkSelect = document.getElementById("select-drink")
      var vVoucherIdInput = document.getElementById("voucher")
      var vPizaTypeSelect = document.getElementById("select-type")
      var vFullnameInput = document.getElementById("fullname")
      var vEmailInput = document.getElementById("email")
      var vPhoneInput = document.getElementById("phone")
      var vAddress = document.getElementById("address")
      var vMessage = document.getElementById("msg")
      // Gán giá trị vào object
      paramObject.kichCo = vSizeComboSelect.value;
      paramObject.idLoaiNuocUong = vDrinkSelect.value;
      paramObject.idVourcher = vVoucherIdInput.value.trim();
      paramObject.loaiPizza = vPizaTypeSelect.value;
      paramObject.hoTen = vFullnameInput.value.trim();
      paramObject.email = vEmailInput.value.trim();
      paramObject.soDienThoai = vPhoneInput.value.trim();
      paramObject.diaChi = vAddress.value.trim();
      paramObject.loiNhan = vMessage.value.trim();
      // Nếu người dùng chọn size S , M , L
      if (paramObject.kichCo == "S") {
        paramObject.duongKinh = 20
        paramObject.suon = 2
        paramObject.salad = 200
        paramObject.soLuongNuoc = 2
        paramObject.thanhTien = 150000
      }
      else if (paramObject.kichCo == "M") {
        paramObject.duongKinh = 24
        paramObject.suon = 4
        paramObject.salad = 300
        paramObject.soLuongNuoc = 3
        paramObject.thanhTien = 200000
      }
      else if (paramObject.kichCo == "L") {
        paramObject.duongKinh = 30
        paramObject.suon = 8
        paramObject.salad = 500
        paramObject.soLuongNuoc = 4
        paramObject.thanhTien = 250000
      }
    }
    //Hàm kiểm tra dữ liệu
    function isDatavalidate(paramObject) {
      if (!paramObject.kichCo) {
        alert("Hãy chọn cỡ combo")
        return false
      }
      if (!paramObject.idLoaiNuocUong) {
        alert("Hãy chọn loại nước uống")
        return false
      }
      if (!paramObject.loaiPizza) {
        alert("Hãy chọn loại pizza")
        return false
      }
      if (!paramObject.hoTen) {
        alert("Hãy nhập Họ và tên")
        return false
      }
      if (!paramObject.email) {
        alert("Hãy nhập Email")
        return false
      }
      if (!paramObject.soDienThoai) {
        alert("Hãy nhập Số điện thoại")
        return false
      }
      if (!paramObject.diaChi) {
        alert("Hãy nhập Địa chỉ")
        return false
      }
      return true
    }
    function processApiToCreateOrder(paramObject,paramXMLHttp){
      paramXMLHttp.open("POST",gBASE_URL,true)
      paramXMLHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
      paramXMLHttp.send(JSON.stringify(paramObject))
    }
  </script>


</body>

</html>